#include "gpi.h"
#include <string.h>
#include <stdio.h>
#include <malloc.h>
static int opened=0;

void strcpy_noblanks
  GPPROTO((char *target, char *source, int input_count)); 


#ifdef GPPROTOTYPE
int GP_read_stdin(void)
#else
int GP_read_stdin()
#endif

     /* puts  legal lines of input  into gp_lines_of_text */ 

{
  char line[MAX_LINE_LENGTH], line_aux[MAX_LINE_LENGTH];
  char *p2, *p;
  int count = 0, input_count=0;

  if(opened == 1)
    {
      printf("GetparC: Warning: read_stdin already called\n");
      return 0;
    }
    /* Get a line from standard input */

    while (fgets(line,MAX_LINE_LENGTH,stdin) && (count < NLINES_MAX))
      {
	input_count++;
	/*   eventual comments at end of line are discarded   */
                   
	if((p = strchr(line,'#')) != NULL) *p = '\0';
	if((p = strchr(line,'!')) != NULL) *p = '\0';
	strcpy(line_aux,line);
	  
	/* check that line contains the = sign */

	if((p = strchr(line,'=')) != NULL) 
	{
	  /* Divide the line into tokens separated by the = sign */
	  if((p = strtok(line_aux,"=")) == NULL) 
	    {
	      fprintf(stderr,"GP: line %d: illegaly formatted line\n",input_count);
	      exit(-1);
	    }
	  else
	    {
	      /* Check that there is a second word */
	      if((p2 = strtok(NULL,"=")) == NULL) 
		{
		  fprintf(stderr,"GP: line %d: illegaly formatted line\n",input_count);
		  exit(-1);
		}
	      else
		{
		  parname[count] = (char *) malloc(MAX_STRING_LENGTH); 
		  strcpy_noblanks(parname[count],p,input_count);
		  parvalue[count] = (char *) malloc(MAX_STRING_LENGTH); 
		  strcpy(parvalue[count],p2);
		  count++;
		}
	    }
	}
      }
    parname[count] = NULL;
    parvalue[count] = NULL;

  /* Record that stdin was read */

    opened=1;
    return count;
}

void read_stdin__()
{
  int   lines;
  lines = GP_read_stdin();
}

void strcpy_noblanks(char *target, char *source, int input_count)
{
  /* Copies string source to string target stripping all leading and trailing
     blanks. If more than one word is present, complain. */

  char *p, *p2, *string_aux;

  string_aux = (char *) malloc(MAX_STRING_LENGTH);
  strcpy(string_aux,source);
  if((p = strchr(source,' ')) != NULL) 
    {
      /* Divide the line into tokens separated by blanks  */
      if((p = strtok(string_aux," ")) == NULL) 
	{
	  fprintf(stderr,"GP: line %d: blank parameter name?\n",input_count);
	  exit(-1);
	}
      else
	{
	  /* Check that there no second word */
	  if((p2 = strtok(NULL," ")) != NULL) 
	    {
	      fprintf(stderr,"GP: line %d: multi-word parameter name\n",input_count);
	      exit(-1);
	    }
	  else
	    {
	      strcpy(target,p);
	    }
	}
    }
  else
    strcpy(target,source);
}


int GP_opened()
{
  return opened;
}

